package edu.calpoly.android.datewidget;

import java.util.Date;

import edu.calpoly.android.datewidget.R;

import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.widget.RemoteViews;

public class DateWidget extends AppWidgetProvider {
    /** Called when the activity is first created. */
	
    public void updateDate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {

		Date date = new Date();
    	String currentDate = date.toLocaleString();
    	String details = "-- NONE --";
    	
    	final int N = appWidgetIds.length;
    	// Iterate over the widget ID array
    	for (int i = 0; i < N; i++) {
    		int appWidgetId = appWidgetIds[i];
    		// Get instance of Remove view
    		RemoteViews views = new RemoteViews(context.getPackageName(),R.layout.clock_widget);
    		views.setTextViewText(R.id.widget_date, currentDate);
    		views.setTextViewText(R.id.widget_details, details);
    		// Apply modifications to one or more widgets
    		appWidgetManager.updateAppWidget(appWidgetId, views);
    	}
    	
    }
    
    public void updateDate(Context context) {
    	ComponentName thisWidget = new ComponentName(context, DateWidget.class);
    	AppWidgetManager appWidgetManager = AppWidgetManager.getInstance(context);
    	int[] appWidgetIds = appWidgetManager.getAppWidgetIds(thisWidget);
    	updateDate(context, appWidgetManager, appWidgetIds);
    }
    
    @Override 
    public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
    	updateDate(context, appWidgetManager, appWidgetIds);
    }
    
    @Override
    public void onReceive(Context context, Intent intent) {
    	super.onReceive(context, intent);	
    	updateDate(context);
    	
    }
    
}